var config = {
	report : {
		url : "http://card.3g.qq.com/report" //"http://card.cs0309.imtt.qq.com/report"
	},
	log : {
		guidArray : [
		],
		type : 4,
		level : 2
	}
};

;(function() {
    var ua = navigator.userAgent;
    var platform = "android";
    var USE_QB_BRIDGE_VERSION = 5.9;
    var useQBbridge = false;
    var isAndroid = /android/ig.test(ua) && /mqq/ig.test(ua);
    if (typeof mtt_navi !== "undefined") {
        isAndroid = true;
    }
    var isIos = /iphone|ipod/ig.test(ua) && /mqq/ig.test(ua);
    if (isIos) {
        platform = "ios";
    }
    var x5 = {
        commandQueue : [],
        commandQueueFlushing : false,
        resources: {
            base: !0
        }
    };

    x5.callbackId = 0;
    x5.callbacks = {};
    x5.callbackStatus = {
        NO_RESULT:0,
        OK:1,
        CLASS_NOT_FOUND_EXCEPTION:2,
        ILLEGAL_ACCESS_EXCEPTION:3,
        INSTANTIATION_EXCEPTION:4,
        MALFORMED_URL_EXCEPTION:5,
        IO_EXCEPTION:6,
        INVALID_ACTION:7,
        JSON_EXCEPTION:8,
        ERROR:9
    };

    x5.createBridge = function () {
        var bridge = document.createElement("iframe");
        bridge.setAttribute("style", "display:none;");
        bridge.setAttribute("height", "0px");
        bridge.setAttribute("width", "0px");
        bridge.setAttribute("frameborder", "0");
        document.documentElement.appendChild(bridge);
        return bridge;
    };

    x5.exec = function (suc, err, service, action, options) {
        var callbackId = null;
        var command = {
            className : service,
            methodName : action,
            options : {},
            arguments : []
        };

        if (suc || err) {
            callbackId = service + x5.callbackId++;
            x5.callbacks[callbackId] = {
                success : suc,
                fail : err
            };
        }

        if (callbackId != null) {
            command.arguments.push(callbackId);
        }

        for (var i = 0; i < options.length; ++i) {
            var arg = options[i];
            if (arg == undefined || arg == null) {
                continue;
            } else if (typeof(arg) == 'object') {
                command.options = arg;
            } else {
                command.arguments.push(arg);
            }
        }

        x5.commandQueue.push(JSON.stringify(command));
        if (x5.commandQueue.length >= 1 && !x5.commandQueueFlushing) {
            if (!x5.bridge) {
                x5.bridge = x5.createBridge();
            }
            x5.bridge.src = "mtt:" + service + ":" + action;
        }
    };

    // 浏览器调用接口
    x5.getAndClearQueuedCommands = function () {
        var json = JSON.stringify(x5.commandQueue);
        x5.commandQueue = [];
        return json;
    };

    // 浏览器执行成功的回调函数
    x5.callbackSuccess = function(callbackId, args) {
        if (x5.callbacks[callbackId]) {
            if (args.status === x5.callbackStatus.OK) {
                try {
                    if (x5.callbacks[callbackId].success) {
                        x5.callbacks[callbackId].success(args.message);
                    }
                } catch (e) {
                    console.log("Error in success callback: " + callbackId + " = " + e);
                }
            }
            if (!args.keepCallback) {
                delete x5.callbacks[callbackId];
            }
        }
    };

    // 浏览器执行失败的回调函数
    x5.callbackError = function (callbackId, args) {
        if (x5.callbacks[callbackId]) {
            try {
                if (x5.callbacks[callbackId].fail) {
                    x5.callbacks[callbackId].fail(args.message);
                }
            } catch (e) {
                console.log("Error in error callback: " + callbackId + " = " + e);
            }
            if (!args.keepCallback) {
                delete x5.callbacks[callbackId];
            }
        }
    };

    //以下为ios终端接口实现
    x5.ios = x5.ios || {};

    // option的格式如{flag：0}
    x5.ios.notifyImgLoadResult = function(flag, callback) {
        x5.exec(callback, null, "app", "notifyImgLoadResult", [{"flag": flag}]);
    };

    x5.ios.addNaviCard = function (options, succ, err) {
        x5.exec(succ, err, "app", "addNaviCard", [options]);
    };

    x5.ios.deleteNaviCard = function (options, succ, err) {
        x5.exec(succ, err, "app", "deleteNaviCard", [options]);
    };

    x5.ios.isNaviCardExist = function (options, succ, err) {
        x5.exec(succ, err, "app", "isNaviCardExist", [options]);
    };

    x5.ios.openCardPool = function (options, succ, err) {
        x5.exec(succ, err, "app", "openCardPool", [options]);
    };

    x5.ios.openNaviUrl = function (options, succ, err) {
        x5.exec(succ, err, "app", "openNaviUrl", [options]);
    };

    x5.ios.isSupportJSOpenUrl = function (succ, err) {
        x5.exec(succ, err, "app", "isSupportJSOpenUrl", []);
    };

    x5.ios.isNoPicStyle = function (succ, err) {
        x5.exec(succ, err, "app", "isNoPicStyle", []);
    };

    x5.ios.getHistory = function(options, succ, err) {
        x5.exec(succ, err, "video", "getHistory", [options]);
    };
    x5.ios.playEpisode = function(options, succ, err) {
        x5.exec(succ, err, "video", "playEpisode", [options]);
    };

    x5.ios.getNovelHistory = function(options, succ, err) {
        x5.exec(succ, err, "app", "getNovelHistory", [options]);
    };

    x5.ios.isNaviCardShowHistory= function (options, succ, err) {
        x5.exec(succ, err, "app", "isNaviCardShowHistory", [options]);
    };
    x5.ios.getSwitchStatus= function (options, succ, err) {
        x5.exec(succ, err, "app", "getSwitchStatus", [options]);
    };
    x5.ios.setNaviCardLocalStorage = function(options, succ, err) {
        x5.exec(succ, err, "app", "setNaviCardLocalStorage", [options]);
    };

    x5.ios.getNaviCardLocalStorage = function(options, succ, err) {
        x5.exec(succ, err, "app", "getNaviCardLocalStorage", [options]);
    };

    x5.ios.notifyNaviCardRelayout = function(succ, err) {
        x5.exec(succ, err, "app", "notifyNaviCardRelayout", []);
    };
    x5.ios.reportStatDatas = function(options, succ, err) {
        x5.exec(succ, err, "app", "reportStatDatas", [options]);
    };
    x5.ios.getBrowserParam = function (succ, err) {
        x5.exec(succ, err, "app", "getBrowserParam", []);
    };
    x5.ios.getGeoLocation = function (succ, err) {
        x5.exec(succ, err, "app", "getGeoLocation", []);
    };
    x5.ios.replaceNaviCard = function (options, succ, err) {
        x5.exec(succ, err, "app", "replaceNaviCard", [options]);
    };
    x5.ios.addRPTStatistics = function (options, succ, err) {
        x5.exec(succ, err, "app", "addRPTStatistics", [options]);
    };
    x5.ios.openSearchUrl = function (options, succ, err) {
        x5.exec(succ, err, "app", "openSearchUrl", [options]);
    };
	x5.ios.openTypeUrl = function(succ, err, options){
		x5.exec(succ, err, "app", "openTypeUrl", [options]);
	};
    
    window.T5Kit = {};
    for (var i in x5) {
        T5Kit[i] = x5[i];
    }
    // android相关的接口，5.7以上使用qb_bridge
    x5.android = x5.android || {};

    x5.android.addNaviCard = function(options, suc, err) {
        if (useQBbridge) {
            try {
                qb_bridge.exec(suc, err, "navicard", "addNaviCard", options);
            } catch(e) {
                err && err();
            }
        }else if (typeof mtt !== "undefined") {
            try {
                if (mtt.addNaviCard) {
                    mtt.addNaviCard(JSON.stringify(options), suc + "", err + "");
                }
            } catch(e) {
                err && err();
            }
        } else {
            err && err();
        }
    };

    x5.android.deleteNaviCard = function(options, suc, err) {
        if (useQBbridge) {
            try {
                qb_bridge.exec(suc, err, "navicard", "deleteNaviCard", options);
            } catch(e) {
                err && err();
            }
        }else if (typeof mtt !== "undefined") {
            try {
                if (mtt.deleteNaviCard) {
                    mtt.deleteNaviCard(JSON.stringify(options), suc + "", err + "");
                }
            } catch(e) {
                err && err();
            }
        } else {
            err && err();
        }
    };

    x5.android.isNaviCardExist = function(options, suc, err) {
        if (useQBbridge) {
            try {
                qb_bridge.exec(function(opt) {
                    suc(opt.result);
                }, err, "navicard", "isNaviCardExist", options);
            } catch(e) {
                err && err();
            }
        }else if (typeof mtt !== "undefined") {
            try {
                if (mtt.isNaviCardExist) {
                    mtt.isNaviCardExist(JSON.stringify(options), suc + "", err + "");
                }
            } catch(e) {
                err && err();
            }
        } else {
            err && err();
        }
    };

    x5.android.openCardPool = function(options, suc, err) {
        if (useQBbridge) {
            try {
                qb_bridge.exec(suc, err, "navicard", "openCardPool", options);
            } catch(e) {
                err && err();
            }
        } else if (typeof mtt !== "undefined") {
            try
            {
                if (mtt.openCardPool) {
                    mtt.openCardPool(JSON.stringify(options), suc + "", err + "");
                }
            } catch(e) {
                err && err();
            }
        } else {
            err && err();
        }
    };
    // 图片加载接口
    x5.android.notifyImgLoadResult = function(flag, callback) {
        var ret = -1;
        if (useQBbridge) {
            try {
                qb_bridge.exec(suc, err, "navicard", "notifyImgLoadResult", "");
                ret = 0
            } catch(e) {
                ret = -1;
            }
        } else if (typeof mtt_navi !== "undefined") {
            try {
                mtt_navi.notifyImgLoadResult(flag, callback + "");
                ret = 0;
            } catch(e) {
                ret = -1;
            }
        } else {
            ret =  -1;
        }
        return ret;
    };

    /*
     options
     {
     url: url信息，
     rpt: rpt信息
     }
     */
    x5.android.openNaviUrl = function(options, suc, err) {
        if (useQBbridge) {
            try {
                qb_bridge.exec(suc, err, "navicard", "openNaviUrl", options);
            } catch(e) {
                err && err();
            }
        } else if (typeof mtt_navi !== "undefined") {
            try {
                if (mtt_navi.openNaviUrl) {
                    mtt_navi.openNaviUrl(JSON.stringify(options), suc + "", err + "");
                }
            } catch(e) {
                err && err();
            }
        } else {
            err && err();
        }
    };

    /**
     * 是否支持打开URL
     */
    x5.android.isSupportJSOpenUrl = function() {
        var ret = false;
        if (useQBbridge) {
            try {
                ret = qb_bridge.exec(null, null, "navicard", "isSupportJSOpenUrl", "");
                ret = ret == "1" ? true : false; //5.7返回字符串
            } catch(e) {
                ret = false;
            }
        } else if (typeof mtt_navi !== "undefined") {
            try {
                if (mtt_navi.isSupportJSOpenUrl) {
                    ret = mtt_navi.isSupportJSOpenUrl();
                }
            } catch(e) {
                ret = false;
            }
        }
        return ret;
    };

    x5.android.isNoPicStyle = function() {
        var ret = false;
        if (useQBbridge) {
            try {
                ret = qb_bridge.exec(null, null, "navicard", "isNoPicStyle", "");
            } catch(e) {
                ret = false;
            }
        } else if (typeof mtt_navi !== "undefined") {
            try {
                if (mtt_navi.isNoPicStyle) {
                    ret = mtt_navi.isNoPicStyle();
                }
            } catch(e) {
                ret = false;
            }
        }
        return ret;
    };
    //终端还未完成5.7新接口
    x5.android.playEpisode = function(options, suc, err) {
        if (useQBbridge) {
            try {
                qb_bridge.exec(null, null, "navicard", "getVideoHistory", options);
            } catch(e) {
                err && err();
            }
        } else if (x5mtt) {
            if (x5mtt.playEpisode) {
                var result = x5mtt.playEpisode(options);
                suc && suc(result);
            }
        } else{
            err && err();
        }
    };

    x5.android.getHistory = function(options, succ, fail) {
        if (useQBbridge) {
            try {
                var result = qb_bridge.exec(null, null, "navicard", "getVideoHistory", options);
                succ && succ(result);
            } catch(e) {
                fail && fail();
            }
        } else if (x5mtt) {
            if (x5mtt.getHistory) {
                var result = x5mtt.getHistory(options);
                succ && succ(result);
            }
        } else{
            fail && fail();
        }
    };

    x5.android.getNovelHistory = function(options, succ, fail) {
        if (useQBbridge) {
            try {
                var result = qb_bridge.exec(null, null, "navicard", "getNovelHistory", options);
                succ && succ(result);
            } catch(e) {
               fail && fail();
            }
        } else if (x5mtt) {
            if (x5mtt.getNovelHistory) {
                var result = x5mtt.getNovelHistory(options);
                succ && succ(result);
            }
        } else{
            fail && fail();
        }
    };

    x5.android.setNaviCardLocalStorage = function(options, suc, err) {
        if (useQBbridge) {
            try {
                qb_bridge.exec(suc, err, "navicard", "setNaviCardLocalStorage", options);
            } catch(e) {
                err && err();
            }
        } else if (typeof mtt_navi !== "undefined") {
            try {
                if (mtt_navi.setNaviCardLocalStorage) {
                    mtt_navi.setNaviCardLocalStorage(JSON.stringify(options), suc + "", err + "");
                }
            } catch(e) {
                err && err();
            }
        } else {
            err && err();
        }
    };
    x5.android.reportStatDatas = function(options, suc, err){
        if (useQBbridge) {
            try {
                qb_bridge.exec(suc, err, "navicard", "reportStatDatas", options);
            } catch(e) {
                err && err();
            }
        } else if (typeof mtt_navi !== "undefined") {
            try {
                if(mtt_navi.reportStatDatas) {
                    mtt_navi.reportStatDatas(JSON.stringify(options), suc + "", err + "");
                }
            } catch(e) {
                err && err();
            }
        } else {
            err && err();
        }
    };
    x5.android.getNaviCardLocalStorage = function(options, suc, err){
        if (useQBbridge) {
            try {
                var result = qb_bridge.exec(null, null, "navicard", "getNaviCardLocalStorageSync", options);
                if (typeof result == "string") {
                    result = JSON.parse(result);
                }
                if (result) {
                    suc && suc(result.result[0]);
                } else {
                    suc && suc(result);
                }
                
            } catch(e) {
                err && err();
            }
        } else if (typeof mtt_navi !== "undefined") {
            try {
                if (mtt_navi.getNaviCardLocalStorage) {
                    var result = mtt_navi.getNaviCardLocalStorage(JSON.stringify(options));
                    if(typeof result == "string"){
                        result = JSON.parse(result);
                    }
                    suc && suc(result);
                }
            } catch(e) {
                err && err();
            }
        } else {
            err && err();
        }
    };

    x5.android.notifyNaviCardRelayout = function(){
        if (useQBbridge) {
            try {
                qb_bridge.exec(null, null, "navicard", "notifyNaviCardRelayout", "");
            } catch(e) {
               
            }
        } else if (typeof mtt_navi !== "undefined") {
            try {
                if (mtt_navi.notifyNaviCardRelayout) {
                    mtt_navi.notifyNaviCardRelayout();
                }
            } catch(e) {
            }
        }
    };

    x5.android.isNaviCardShowHistory = function(options, suc, err){
        if (useQBbridge) {
            try {
                qb_bridge.exec(suc, err, "navicard", "isNaviCardShowHistory", options);
            } catch(e) {
                err && err();
            }
        } else if (typeof mtt_navi !== "undefined") {
            try {
                if (mtt_navi.isNaviCardShowHistory) {
                    mtt_navi.isNaviCardShowHistory(JSON.stringify(options), suc + "", err + "");
                }
            } catch(e) {
                err && err();
            }
        } else {
            err && err();
        }
    };
    //5.7以后才有同步异步只说，5.7以上默认为同步加载，也可调用异步接口getSwitchStatusASync
    x5.android.getSwitchStatusSync = function(options, suc, err) {
        if (useQBbridge) {
            try {
                var result = qb_bridge.exec(null, null, "navicard", "getSwitchStatusSync", options);
                if (typeof result == "string") {
                    result = JSON.parse(result);
                }
                suc && suc(result);
            } catch(e) {
                err && err();
            }
        } else if (typeof mtt_navi !== "undefined") {
            try {
                if (mtt_navi.getSwitchStatus) {
                    var result = mtt_navi.getSwitchStatus(JSON.stringify(options));
                    if (typeof result == "string") {
                        result = JSON.parse(result);
                    }
                    suc && suc(result);
                }
            } catch(e) {
                err && err();
            }
        } else {
            err && err();
        }
    };
    //只在5.7以上有效，5.7以下异步有bug，故没有使用
    x5.android.getSwitchStatusASync = function(options, suc, err){
        if (useQBbridge) {
            try {
                qb_bridge.exec(suc, err, "navicard", "getSwitchStatusASync", options);
            } catch(e) {
                err && err();
            }
        }else {
            err && err();
        }
    };
    //终端还未完成5.7新接口
    x5.android.getGeoLocation = function(suc, err) {
        if (useQBbridge) {
            try {
                qb_bridge.exec(suc, err, "device", "geolocation", "");
            } catch(e) {
                err && err();
            }
        } else if (typeof x5mtt !== "undefined") {
            try {
                if (x5mtt.getGeolocation) {
                    var options = JSON.stringify({
                        cbSuccess : suc.name + "",
                        cbError : err.name + ""
                    });
                    x5mtt.getGeolocation(options);
                }
            } catch(e) {
                err && err();
            }
        } else {
            err && err();
        }
    };

    x5.android.replaceNaviCard = function(options, suc, err) {
        if (useQBbridge) {
            try {
                qb_bridge.exec(suc, err, "navicard", "replaceNaviCard", options);
            } catch(e) {
                err && err();
            }
        } else if (typeof mtt_navi !== "undefined") {
            try {
                if (mtt_navi.replaceNaviCard) {
                    mtt_navi.replaceNaviCard(JSON.stringify(options), suc + "", err + "");
                }
            } catch(e) {
                err && err();
            }
        } else {
            err && err();
        }
    };

    x5.android.addRPTStatistics = function(options, suc, err) {
        if (useQBbridge) {
            try {
                qb_bridge.exec(suc, err, "navicard", "addRPTStatistics", options);
            } catch(e) {
                err && err();
            }
        } else if (typeof mtt_navi !== "undefined") {
            try {
                if (mtt_navi.addRPTStatistics) {
                    mtt_navi.addRPTStatistics(JSON.stringify(options), suc + "", err + "");
                }
            } catch(e) {
                err && err();
            }
        } else {
            err && err();
        }
    };
    x5.android.openSearchUrl = function(options, suc, err) {
        if (useQBbridge) {
            try {
                qb_bridge.exec(suc, err, "navicard", "openSearchUrl", options);
            } catch(e) {
                err && err();
            }
        } else if (typeof mtt_navi !== "undefined") {
            try {
                if (mtt_navi.openSearchUrl) {
                    mtt_navi.openSearchUrl(JSON.stringify(options), suc + "", err + "");
                }
            } catch(e) {
                err && err();
            }
        } else {
            err && err();
        }
    };
    
    x5.android.getSkinTheme = function() {
        var ret = -1;
        if (useQBbridge) {
            try {
                ret = qb_bridge.exec(null, null, "navicard", "getSkinTheme", "");
                ret = parseInt(ret);
            } catch(e) {
                
            }
        } else if (typeof mtt_navi !== "undefined") {
            if (mtt_navi.getSkinTheme) {
                ret = mtt_navi.getSkinTheme();
            }
        }
        return ret;
    };
    
    x5.android.isNightSkin = function() {
        var ret = false;
        if (useQBbridge) {
            try {
                ret = qb_bridge.exec(null, null, "navicard", "isNightSkin", "");
                ret = ret == "1" ? true : false;
            } catch(e) {
            }
        } else if (typeof mtt_navi !== "undefined") {
            if (mtt_navi.isNightSkin) {
                ret = mtt_navi.isNightSkin();
            }
        }
        return ret;
    };
    
    x5.android.onGetOffsetHeight = function(height) {
        var ret = false;
        if (useQBbridge) {
            try {
                ret = qb_bridge.exec(null, null, "navicard", "onGetOffsetHeight", {"height" : height});
            } catch(e) {
            }
        } else if (typeof mtt_navi !== "undefined") {
            if (mtt_navi.onGetOffsetHeight) {
                ret = mtt_navi.onGetOffsetHeight(height);
            }
        }
        return ret;
    };
	
	x5.android.openTypeUrl = function(suc, err, options){
		if (useQBbridge) {
            try {
                qb_bridge.exec(suc, err, "navicard", "openTypeUrl", options);
            } catch(e) {
                err && err();
            }
        } else if (typeof mtt_navi !== "undefined") {
            try {
                if (mtt_navi.openTypeUrl) {
                    mtt_navi.openTypeUrl(JSON.stringify(options), suc + "", err + "");
                }
            } catch(e) {
                err && err();
            }
        } else {
            err && err();
        }
	};
    
    x5.addNaviCard = function(options, suc, err) {
        if (!isAndroid && !isIos) {
            err && err();
        } else {
            if (isAndroid) {
                x5.android.addNaviCard(options, suc, err);
            } else {
                x5.ios.addNaviCard(options, suc, err);
            }
        }
    };

    x5.deleteNaviCard = function(options, suc, err) {
        if (!isAndroid && !isIos) {
            err && err();
        } else {
            if (isAndroid) {
                x5.android.deleteNaviCard(options, suc, err);
            } else {
                x5.ios.deleteNaviCard(options, suc, err);
            }
        }
    };

    x5.isNaviCardExist = function(options, suc, err) {
        if (!isAndroid && !isIos) {
            err && err();
        } else {
            if (isAndroid) {
                x5.android.isNaviCardExist(options, suc, err);
            } else {
                x5.ios.isNaviCardExist(options, suc, err);
            }
        }
    };

    x5.openCardPool = function(options, succ, err) {
        if (!isAndroid && !isIos) {
            err && err();
        } else {
            if (isAndroid) {
                x5.android.openCardPool(options, succ, err);
            } else if (isIos) {
                x5.ios.openCardPool(options, succ, err);
            }
        }
    };
    /**
     * 图片加载
     * @param flag 0: 标识加载成功， 1：标识加载失败
     * @param callback 供浏览器调起的接口
     */
    x5.notifyImgLoadResult = function(flag, callback) {
        if (!isIos && !isAndroid) {
            return -1;
        } else {
            if (isAndroid) {
                return x5.android.notifyImgLoadResult(flag, callback);
            } else if (isIos) {
                x5.ios.notifyImgLoadResult(flag, callback);
                return 0;
            }
        }
    };

    /**
     *
     * @param options {
     *  url:
     *  rpt:
     * }
     * @param suc
     * @param err
     */
    x5.openNaviUrl = function(options, suc, err){
        if (!isAndroid && !isIos) {
            err && err();
        } else {
            if (isAndroid) {
                x5.android.openNaviUrl(options, suc, err);
            } else if (isIos) {
                x5.ios.openNaviUrl(options, suc, err);
            }
        }
    };

    /**
     * 是否支持打开URL
     * @param suc 支持
     * @param err 不支持
     */
    x5.isSupportJSOpenUrl = function(suc, err){
        if (!isAndroid && !isIos) {
            err && err();
        } else {
            if (isAndroid) {
                var ret = x5.android.isSupportJSOpenUrl();
                if (ret) {
                    suc && suc();
                } else {
                    err && err();
                }
            } else {
                x5.ios.isSupportJSOpenUrl(suc, err);
            }
        }
    };

    x5.isNoPicStyle = function(suc, err) {
        if (!isAndroid && !isIos) {
            err && err();
        } else {
            if (isAndroid) {
                var ret = x5.android.isNoPicStyle();
                ret = ret == "1" ? true : false; //5.7只能返回字符串，不能返回数值型或者布尔型
                if (ret) { 
                    suc && suc();
                } else {
                    err && err();
                }
            } else {
                x5.ios.isNoPicStyle(suc, err);
            }
        }
    };

    x5.getHistory = function(paramString, succ, fail) {
        if (!isIos && ! isAndroid) {
            succ && succ(JSON.stringify({
                history: [],
                total: - 1
            }));
        } else {
            if (isAndroid) {
                x5.android.getHistory(paramString, succ, fail);
            } else if (isIos) {
                x5.ios.getHistory(paramString, succ, fail);
            }
        }
    };

    x5.playEpisode = function(paramString, succ, err) {
        if (!isIos && ! isAndroid) {
            return;
        } else {
            if (isAndroid) {
                x5.android.playEpisode(paramString, succ, err);
            } else {
                x5.ios.playEpisode(paramString, succ, err);
            }
        }
    };

    x5.isNaviCardShowHistory = function(options, suc, err){
        if (!isAndroid && !isIos) {
            err && err();
        } else {
            if (isAndroid) {
                x5.android.isNaviCardShowHistory(options, suc, err);
            } else {
                x5.ios.isNaviCardShowHistory(options, suc, err);
            }
        }
    };
    x5.getSwitchStatus = function(options, suc, err){
        if (!isAndroid && !isIos) {
            err && err();
        } else {
            if (isAndroid) {
                x5.android.getSwitchStatusSync(options, suc, err);
            } else {
                x5.ios.getSwitchStatus(options, suc, err);
            }
        }
    };
    x5.getNovelHistory = function(options, succ, fail) {
        if (!isIos && ! isAndroid) {
            succ && succ(JSON.stringify({
                history: [],
                total: - 1
            }));
        } else {
            if (isAndroid) {
                x5.android.getNovelHistory(options, succ, fail);
            } else {
                x5.ios.getNovelHistory(options, succ, fail);
            }
        }
    };

    x5.setNaviCardLocalStorage = function(options, suc, err) {
        if (!isAndroid && !isIos) {
            err && err();
        } else {
            if (isAndroid) {
                x5.android.setNaviCardLocalStorage(options, suc, err);
            } else {
                x5.ios.setNaviCardLocalStorage(options, suc, err);
            }
        }
    };

    x5.getNaviCardLocalStorage = function(options, suc, err){
        if (!isAndroid && !isIos) {
            err && err();
        } else {
            if (isAndroid) {
                x5.android.getNaviCardLocalStorage(options, suc, err);
            } else {
                x5.ios.getNaviCardLocalStorage(options, suc, err);
            }
        }
    };

    x5.getBrowserParam = function(succ, err){
        if (!isIos && !isAndroid) {
            err && err();
        }
        else{
            if (isAndroid) {
                var para = mtt.getBrowserParam();
                if (para && para != "") {
                    succ && succ(para);
                } else{
                    err && err();
                }
            } else{
                x5.ios.getBrowserParam(succ, err);
            }
        }
    };

    x5.notifyNaviCardRelayout = function() {
        if (!isAndroid && !isIos) {
        } else {
            if (isAndroid) {
                x5.android.notifyNaviCardRelayout();
            } else {
                x5.ios.notifyNaviCardRelayout();
            }
        }
    };

    x5.reportStatDatas = function(options, suc, err) {
        if (!isAndroid && !isIos) {
            err && err();
        } else {
            if (isAndroid) {
                x5.android.reportStatDatas(options, suc, err);
            } else {
                x5.ios.reportStatDatas(options, suc, err);
            }
        }
    };

    x5.getGeoLocation = function(suc, err) {
        if (!isAndroid && !isIos) {
            err && err();
        } else {
            if (isAndroid) {
                x5.android.getGeoLocation(suc, err);
            } else {
                x5.ios.getGeoLocation(suc, err);
            }
        }
    };

    x5.replaceNaviCard = function(options, suc, err) {
        if (!isAndroid && !isIos) {
            err && err();
        } else {
            if (isAndroid) {
                x5.android.replaceNaviCard(options, suc, err);
            } else {
                x5.ios.replaceNaviCard(options, suc, err);
            }
        }
    };
    x5.addRPTStatistics = function(options, suc, err) {
        if (!isAndroid && !isIos) {
            err && err();
        } else {
            if (isAndroid) {
                x5.android.addRPTStatistics(options, suc, err);
            } else {
                x5.ios.addRPTStatistics(options, suc, err);
            }
        }
    };
    x5.openSearchUrl = function(options, suc, err) {
        if (!isAndroid && !isIos) {
            err && err();
        } else {
            if (isAndroid) {
                x5.android.openSearchUrl(options, suc, err);
            } else {
                x5.ios.openSearchUrl(options, suc, err);
            }
        }
    };
	// 点击按钮通知终端更新图标
	x5.openTypeUrl = function(suc, err, options) {
        if (!isAndroid && !isIos) {
            err && err();
        } else {
			if(qbVersion >= 6.1){
				if (isAndroid) {
					x5.android.openTypeUrl(suc, err, options);
				} else {
					x5.ios.openTypeUrl(suc, err, options);
				}
			}
        }
    };
        
    //以下为Android5.7以上接口用到，原有的mtt有闭包bug，5.7以后使用qb_bridge实现。
    var qbVersion = -1;
    if (isAndroid) {
        var ver = ua.match(/mqqbrowser\/([0-9\.]+)/i);
        if (ver && ver.length) {
            qbVersion = ver[1];
        }
        if (qbVersion >= USE_QB_BRIDGE_VERSION) {//5.x
            if (window.qb_bridge == undefined) {
               window.qb_bridge = {
                    nativeExec : function(service, action, callbackId, argsJson) {
                        return prompt(argsJson, 'mtt:[' + [service, action, callbackId] + ']');
                    }
                }; 
            }
            var qbCallbackId = 0;
            var callbacks = {};

            qb_bridge.exec = function(success, fail, service, action, args) {
                var callbackId = service + qbCallbackId++;
                var argsJson = args == null ? "" 
                    : (typeof args == "object" ? JSON.stringify(args) : args + "");

                if (success || fail) {
                    callbacks[callbackId] = {success: success, fail: fail};
                }
                var exception = null;
                var ret = null;
                try {
                    ret = qb_bridge.nativeExec(service, action, callbackId, argsJson);
                } catch(e) {
                    exception = e;
                }
                
                return ret;
            };

            qb_bridge.callbackFromNative = function(callbackId, args) {
                var callback = callbacks[callbackId];
                var argsJson = JSON.parse(args);
                if (callback) {
                    if (argsJson.succ) {
                        callback.success && callback.success(argsJson.msg);
                    } else {
                        callback.fail && callback.fail(argsJson.msg);
                    }

                    if (!argsJson.keep) {
                        delete callbacks[callbackId];
                    }
                }
            };
        }
    } else if (!isIos) {// pc
        window.qb_bridge = {
            nativeExec : function(service, action, callbackId, argsJson) {
                return null;
            }
        };  
    }
   
    x5.getQBVersion = function() {
        return qbVersion;
    };
    
    x5.getPlatform = function() {
        return platform;
    }
    
    x5.isUseQBbridge = function() {
        return useQBbridge;
    }
    
    if (isAndroid) {
        if (qbVersion >= USE_QB_BRIDGE_VERSION) {
            var ret = qb_bridge.exec(null, null, "qb", "appVersion", null);
            if (ret) {
                qbVersion = (ret.match(/^\d\.\d/))[0];
            }
        }
        if (qbVersion >= USE_QB_BRIDGE_VERSION && typeof qb_bridge !== "undefined") {
            useQBbridge = true;
        }
    } else if (isIos) {
        x5.ios.getBrowserParam(function(info) {
            if (info) {
                try {
                    info = JSON.parse(info);
                    var qua = info.qua + "";
                    qua = qua.match(/([0-9\.]+)/ig, '');
                    if (qua && qua.length > 0) {
                        if (qua[0] && qua[0].length == 2) {
                            qbVersion = qua[0][0] + "." + qua[0][1];
                        };
                        
                    }
                } catch(e) {
                    
                }
            }
        }, function() {
        });
    }   
    window.x5 = x5;
})();